; Handled by the compiler, depending on whether we're statically
; linking or not.
; (declare (unit xmms2client))
(use srfi-4)

#>
#include <stdlib.h>

#include <xmmsclient/xmmsclient.h>
<#

#>?

// These two were converted from macros to functions.
___safe void XMMS_CALLBACK_SET(xmmsc_connection_t *conn,
	// was xmmsc_result_t *meth,
	xmmsc_result_t *(*)( xmmsc_connection_t * ),
	// was xmmsc_result_notifier_t callback, 
	void (*)(xmmsc_result_t *, void *),
	void *udata)
{
        XMMS_CALLBACK_SET_FULL(conn,meth,callback,udata,NULL);
}

___safe void XMMS_CALLBACK_SET_FULL(xmmsc_connection_t *conn,
	// was xmmsc_result_t *meth,
	xmmsc_result_t *(*)( xmmsc_connection_t * ),
	// was xmmsc_result_notifier_t callback,
	void (*)(xmmsc_result_t *, void *),
	void *udata, void *free_func)
{
        xmmsc_result_t *res = meth (conn);
        xmmsc_result_notifier_set_full (res, callback, udata, free_func);
        xmmsc_result_unref (res);
}



const int XMMS_OBJECT_CMD_ARG_NONE;
const int XMMS_OBJECT_CMD_ARG_UINT32;
const int XMMS_OBJECT_CMD_ARG_INT32;
const int XMMS_OBJECT_CMD_ARG_STRING;
const int XMMS_OBJECT_CMD_ARG_STRINGLIST;
const int XMMS_OBJECT_CMD_ARG_DICT;
const int XMMS_OBJECT_CMD_ARG_LIST;
const int XMMS_OBJECT_CMD_ARG_PROPDICT;
const int XMMS_OBJECT_CMD_ARG_COLL;
const int XMMS_OBJECT_CMD_ARG_BIN;

const int XMMSC_RESULT_VALUE_TYPE_NONE = XMMS_OBJECT_CMD_ARG_NONE;
const int XMMSC_RESULT_VALUE_TYPE_UINT32 = XMMS_OBJECT_CMD_ARG_UINT32;
const int XMMSC_RESULT_VALUE_TYPE_INT32 = XMMS_OBJECT_CMD_ARG_INT32;
const int XMMSC_RESULT_VALUE_TYPE_STRING = XMMS_OBJECT_CMD_ARG_STRING;
const int XMMSC_RESULT_VALUE_TYPE_DICT = XMMS_OBJECT_CMD_ARG_DICT;
const int XMMSC_RESULT_VALUE_TYPE_PROPDICT = XMMS_OBJECT_CMD_ARG_PROPDICT;
const int XMMSC_RESULT_VALUE_TYPE_COLL = XMMS_OBJECT_CMD_ARG_COLL;
const int XMMSC_RESULT_VALUE_TYPE_BIN = XMMS_OBJECT_CMD_ARG_BIN

/* From xmmsclient.h */
typedef struct xmmsc_connection_St xmmsc_connection_t;
typedef struct xmmsc_result_St xmmsc_result_t;
typedef int xmmsc_result_type_t;
typedef int xmmsc_result_value_type_t;
typedef int xmmsc_coll_token_type_t;

/* /usr/include/xmms2/xmmsc/xmmsc_idnumbers.h */
typedef const char* xmmsc_coll_namespace_t;

/* From /usr/include/stdint.h */
typedef unsigned int              uint32_t;
typedef int                       int32_t;

const int XMMSC_RESULT_CLASS_DEFAULT;
const int XMMSC_RESULT_CLASS_SIGNAL;
const int XMMSC_RESULT_CLASS_BROADCAST;

typedef void (*xmmsc_user_data_free_func_t) (void *user_data);

___safe xmmsc_connection_t *xmmsc_init (const char *clientname);
___safe int xmmsc_connect (xmmsc_connection_t *, const char *);
___safe void xmmsc_ref (xmmsc_connection_t *c);
___safe void xmmsc_unref (xmmsc_connection_t *c);
___safe void xmmsc_lock_set (xmmsc_connection_t *conn, void *lock, void (*lockfunc)(void *), void (*unlockfunc)(void *));
___safe void xmmsc_disconnect_callback_set (xmmsc_connection_t *c, void (*callback) (void*), void *userdata);
___safe void xmmsc_disconnect_callback_set_full (xmmsc_connection_t *c, void (*callback) (void*), void *userdata, xmmsc_user_data_free_func_t free_func);

___safe void xmmsc_io_need_out_callback_set (xmmsc_connection_t *c, void (*callback) (int, void*), void *userdata);
___safe void xmmsc_io_need_out_callback_set_full (xmmsc_connection_t *c, void (*callback) (int, void*), void *userdata, xmmsc_user_data_free_func_t free_func);
___safe void xmmsc_io_disconnect (xmmsc_connection_t *c);
___safe int xmmsc_io_want_out (xmmsc_connection_t *c);
___safe int xmmsc_io_out_handle (xmmsc_connection_t *c);
___safe int xmmsc_io_in_handle (xmmsc_connection_t *c);
___safe int xmmsc_io_fd_get (xmmsc_connection_t *c);

___safe char *xmmsc_get_last_error (xmmsc_connection_t *c);

xmmsc_result_t *xmmsc_quit(xmmsc_connection_t *);

xmmsc_result_t *xmmsc_broadcast_quit (xmmsc_connection_t *c);

/* get user config dir */
const char *xmmsc_userconfdir_get (char *buf, int len);


/*
 * PLAYLIST ************************************************
 */

/* commands */
xmmsc_result_t *xmmsc_playlist_list (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_playlist_create (xmmsc_connection_t *c, const char *playlist);
xmmsc_result_t *xmmsc_playlist_shuffle (xmmsc_connection_t *c, const char *playlist);
xmmsc_result_t *xmmsc_playlist_add_args (xmmsc_connection_t *c, const char *playlist, const char *, int, const char **);
xmmsc_result_t *xmmsc_playlist_add_url (xmmsc_connection_t *c, const char *playlist, const char *url);
xmmsc_result_t *xmmsc_playlist_add_id (xmmsc_connection_t *c, const char *playlist, uint32_t id);
xmmsc_result_t *xmmsc_playlist_add_encoded (xmmsc_connection_t *c, const char *playlist, const char *url);
xmmsc_result_t *xmmsc_playlist_add_collection (xmmsc_connection_t *c, const char *playlist, xmmsc_coll_t *coll, const char **order);
xmmsc_result_t *xmmsc_playlist_remove_entry (xmmsc_connection_t *c, const char *playlist, uint32_t);
xmmsc_result_t *xmmsc_playlist_clear (xmmsc_connection_t *c, const char *playlist);
xmmsc_result_t *xmmsc_playlist_remove (xmmsc_connection_t *c, const char *playlist);
xmmsc_result_t *xmmsc_playlist_list_entries (xmmsc_connection_t *c, const char *playlist);
xmmsc_result_t *xmmsc_playlist_sort (xmmsc_connection_t *c, const char *playlist, const char** properties);
xmmsc_result_t *xmmsc_playlist_set_next (xmmsc_connection_t *c, uint32_t);
xmmsc_result_t *xmmsc_playlist_set_next_rel (xmmsc_connection_t *c, int32_t);
xmmsc_result_t *xmmsc_playlist_move_entry (xmmsc_connection_t *c, const char *playlist, uint32_t, uint32_t);
xmmsc_result_t *xmmsc_playlist_current_pos (xmmsc_connection_t *c, const char *playlist);
xmmsc_result_t *xmmsc_playlist_current_active (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_playlist_insert_args (xmmsc_connection_t *c, const char *playlist, int pos, const char *url, int numargs, const char **args);
xmmsc_result_t *xmmsc_playlist_insert_url (xmmsc_connection_t *c, const char *playlist, int pos, const char *url);
xmmsc_result_t *xmmsc_playlist_insert_id (xmmsc_connection_t *c, const char *playlist, int pos, uint32_t id);
xmmsc_result_t *xmmsc_playlist_insert_encoded (xmmsc_connection_t *c, const char *playlist, int pos, const char *url);
xmmsc_result_t *xmmsc_playlist_insert_collection (xmmsc_connection_t *c, const char *playlist, int pos, xmmsc_coll_t *coll, const char **order);
xmmsc_result_t *xmmsc_playlist_load (xmmsc_connection_t *c, const char *playlist);
xmmsc_result_t *xmmsc_playlist_radd (xmmsc_connection_t *c, const char *playlist, const char *url);
xmmsc_result_t *xmmsc_playlist_radd_encoded (xmmsc_connection_t *c, const char *playlist, const char *url);

/* broadcasts */
xmmsc_result_t *xmmsc_broadcast_playlist_changed (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_broadcast_playlist_current_pos (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_broadcast_playlist_loaded (xmmsc_connection_t *c);


/*
 * PLAYBACK ************************************************
 */

/* commands */
xmmsc_result_t *xmmsc_playback_stop (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_playback_tickle (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_playback_start (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_playback_pause (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_playback_current_id (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_playback_seek_ms (xmmsc_connection_t *c, uint32_t milliseconds);
xmmsc_result_t *xmmsc_playback_seek_ms_rel (xmmsc_connection_t *c, int milliseconds);
xmmsc_result_t *xmmsc_playback_seek_samples (xmmsc_connection_t *c, uint32_t samples);
xmmsc_result_t *xmmsc_playback_seek_samples_rel (xmmsc_connection_t *c, int samples);
xmmsc_result_t *xmmsc_playback_playtime (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_playback_status (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_playback_volume_set (xmmsc_connection_t *c, const char *channel, uint32_t volume);
xmmsc_result_t *xmmsc_playback_volume_get (xmmsc_connection_t *c);

/* broadcasts */
xmmsc_result_t *xmmsc_broadcast_playback_volume_changed (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_broadcast_playback_status (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_broadcast_playback_current_id (xmmsc_connection_t *c);

/* signals */
xmmsc_result_t *xmmsc_signal_playback_playtime (xmmsc_connection_t *c);


/*
 * CONFIG **************************************************
 */

/* commands */
xmmsc_result_t *xmmsc_configval_set (xmmsc_connection_t *c, const char *key, const char *val);
xmmsc_result_t *xmmsc_configval_list (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_configval_get (xmmsc_connection_t *c, const char *key);
xmmsc_result_t *xmmsc_configval_register (xmmsc_connection_t *c, const char *valuename, const char *defaultvalue);

/* broadcasts */
xmmsc_result_t *xmmsc_broadcast_configval_changed (xmmsc_connection_t *c);


/*
 * STATS **************************************************
 */

/* commands */
xmmsc_result_t *xmmsc_plugin_list (xmmsc_connection_t *c, uint32_t type);
xmmsc_result_t *xmmsc_main_stats (xmmsc_connection_t *c);

/* broadcasts */
xmmsc_result_t *xmmsc_broadcast_mediainfo_reader_status (xmmsc_connection_t *c);

/* signals */
//xmmsc_result_t *xmmsc_signal_visualisation_data (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_signal_mediainfo_reader_unindexed (xmmsc_connection_t *c);

/*
 * MEDIALIB ***********************************************
 */

/* commands */
int xmmsc_entry_format (char *target, int len, const char *fmt, xmmsc_result_t *res);
xmmsc_result_t *xmmsc_medialib_add_entry (xmmsc_connection_t *conn, const char *url);
xmmsc_result_t *xmmsc_medialib_add_entry_args (xmmsc_connection_t *conn, const char *url, int numargs, const char **args);
xmmsc_result_t *xmmsc_medialib_add_entry_encoded (xmmsc_connection_t *conn, const char *url);
xmmsc_result_t *xmmsc_medialib_get_info (xmmsc_connection_t *, uint32_t);
xmmsc_result_t *xmmsc_medialib_path_import (xmmsc_connection_t *conn, const char *path);
xmmsc_result_t *xmmsc_medialib_path_import_encoded (xmmsc_connection_t *conn, const char *path);
xmmsc_result_t *xmmsc_medialib_rehash (xmmsc_connection_t *conn, uint32_t id);
xmmsc_result_t *xmmsc_medialib_get_id (xmmsc_connection_t *conn, const char *url);
xmmsc_result_t *xmmsc_medialib_remove_entry (xmmsc_connection_t *conn, uint32_t entry);
xmmsc_result_t *xmmsc_medialib_move_entry (xmmsc_connection_t *conn, uint32_t entry, const char *url);

xmmsc_result_t *xmmsc_medialib_entry_property_set_int (xmmsc_connection_t *c, uint32_t id, const char *key, int32_t value);
xmmsc_result_t *xmmsc_medialib_entry_property_set_int_with_source (xmmsc_connection_t *c, uint32_t id, const char *source, const char *key, int32_t value);

xmmsc_result_t *xmmsc_medialib_entry_property_set_str (xmmsc_connection_t *c, uint32_t id, const char *key, const char *value);
xmmsc_result_t *xmmsc_medialib_entry_property_set_str_with_source (xmmsc_connection_t *c, uint32_t id, const char *source, const char *key, const char *value);

xmmsc_result_t *xmmsc_medialib_entry_property_remove (xmmsc_connection_t *c, uint32_t id, const char *key);
xmmsc_result_t *xmmsc_medialib_entry_property_remove_with_source (xmmsc_connection_t *c, uint32_t id, const char *source, const char *key);

/* XForm object */
xmmsc_result_t *xmmsc_xform_media_browse (xmmsc_connection_t *c, const char *url);
xmmsc_result_t *xmmsc_xform_media_browse_encoded (xmmsc_connection_t *c, const char *url);

/* Bindata object */
xmmsc_result_t *xmmsc_bindata_add (xmmsc_connection_t *c, const unsigned char *data, unsigned int len);
xmmsc_result_t *xmmsc_bindata_retrieve (xmmsc_connection_t *c, const char *hash);
xmmsc_result_t *xmmsc_bindata_remove (xmmsc_connection_t *c, const char *hash);

/* broadcasts */
xmmsc_result_t *xmmsc_broadcast_medialib_entry_changed (xmmsc_connection_t *c);
xmmsc_result_t *xmmsc_broadcast_medialib_entry_added (xmmsc_connection_t *c);


/*
 * COLLECTION ***********************************************
 */

xmmsc_result_t* xmmsc_coll_get (xmmsc_connection_t *conn, const char *collname, xmmsc_coll_namespace_t ns);
xmmsc_result_t* xmmsc_coll_list (xmmsc_connection_t *conn, xmmsc_coll_namespace_t ns);
xmmsc_result_t* xmmsc_coll_save (xmmsc_connection_t *conn, xmmsc_coll_t *coll, const char* name, xmmsc_coll_namespace_t ns);
xmmsc_result_t* xmmsc_coll_remove (xmmsc_connection_t *conn, const char* name, xmmsc_coll_namespace_t ns);
xmmsc_result_t* xmmsc_coll_find (xmmsc_connection_t *conn, unsigned int mediaid, xmmsc_coll_namespace_t ns);
xmmsc_result_t* xmmsc_coll_rename (xmmsc_connection_t *conn, const char* from_name, const char* to_name, xmmsc_coll_namespace_t ns);
xmmsc_result_t *xmmsc_coll_idlist_from_playlist_file (xmmsc_connection_t *conn, const char *path);
xmmsc_result_t* xmmsc_coll_sync (xmmsc_connection_t *conn);

xmmsc_result_t* xmmsc_coll_query_ids (xmmsc_connection_t *conn, xmmsc_coll_t *coll, const char **order, unsigned int limit_start, unsigned int limit_len);
xmmsc_result_t* xmmsc_coll_query_infos (xmmsc_connection_t *conn, xmmsc_coll_t *coll, const char **order, unsigned int limit_start, unsigned int limit_len, const char **fetch, const char **group);

/* string-to-collection parser */
const int XMMS_COLLECTION_TOKEN_INVALID;
const int XMMS_COLLECTION_TOKEN_GROUP_OPEN;
const int XMMS_COLLECTION_TOKEN_GROUP_CLOSE;
const int XMMS_COLLECTION_TOKEN_REFERENCE;
const int XMMS_COLLECTION_TOKEN_SYMBOL_ID;
const int XMMS_COLLECTION_TOKEN_STRING;
const int XMMS_COLLECTION_TOKEN_PATTERN;
const int XMMS_COLLECTION_TOKEN_INTEGER;
const int XMMS_COLLECTION_TOKEN_SEQUENCE;
const int XMMS_COLLECTION_TOKEN_PROP_LONG;
const int XMMS_COLLECTION_TOKEN_PROP_SHORT;
const int XMMS_COLLECTION_TOKEN_OPSET_UNION;
const int XMMS_COLLECTION_TOKEN_OPSET_INTERSECTION;
const int XMMS_COLLECTION_TOKEN_OPSET_COMPLEMENT;
const int XMMS_COLLECTION_TOKEN_OPFIL_HAS;
const int XMMS_COLLECTION_TOKEN_OPFIL_EQUALS;
const int XMMS_COLLECTION_TOKEN_OPFIL_MATCH;
const int XMMS_COLLECTION_TOKEN_OPFIL_SMALLER;
const int XMMS_COLLECTION_TOKEN_OPFIL_GREATER;
const int XMMS_COLLECTION_TOKEN_OPFIL_SMALLEREQ;
const int XMMS_COLLECTION_TOKEN_OPFIL_GREATEREQ;

#define XMMS_COLLECTION_TOKEN_CUSTOM 32

typedef struct xmmsc_coll_token_St xmmsc_coll_token_t;

struct xmmsc_coll_token_St {
	xmmsc_coll_token_type_t type;
	char *string;
	xmmsc_coll_token_t *next;
};

/*
typedef xmmsc_coll_token_t* (*xmmsc_coll_parse_tokens_f) (const char *str, const char **newpos);
typedef xmmsc_coll_t* (*xmmsc_coll_parse_build_f) (xmmsc_coll_token_t *tokens);
*/

int xmmsc_coll_parse (const char *pattern, xmmsc_coll_t** coll);
/*
int xmmsc_coll_parse_custom (const char *pattern, xmmsc_coll_parse_tokens_f parse_f, xmmsc_coll_parse_build_f build_f, xmmsc_coll_t** coll);
*/

xmmsc_coll_t *xmmsc_coll_default_parse_build (xmmsc_coll_token_t *tokens);
xmmsc_coll_token_t *xmmsc_coll_default_parse_tokens (const char *str, const char **newpos);


/* broadcasts */
xmmsc_result_t *xmmsc_broadcast_collection_changed (xmmsc_connection_t *c);


/*
 * RESULTS
 */

typedef void (*xmmsc_result_notifier_t) (xmmsc_result_t *res, void *user_data);

xmmsc_result_t *xmmsc_result_restart (xmmsc_result_t *res);
void xmmsc_result_run (xmmsc_result_t *res, xmms_ipc_msg_t *msg);
xmmsc_result_type_t xmmsc_result_get_class (xmmsc_result_t *res);
void xmmsc_result_disconnect (xmmsc_result_t *res);

void xmmsc_result_ref (xmmsc_result_t *res);
void xmmsc_result_unref (xmmsc_result_t *res);

___safe void xmmsc_result_notifier_set(
			       xmmsc_result_t *res,
			       // was xmmsc_result_notifier_t func,
			       void (*)(xmmsc_result_t *, void *),
			       void *user_data);
___safe void xmmsc_result_notifier_set_full(
				    xmmsc_result_t *res,
				    // was xmmsc_result_notifier_t func,
				    void (*)(xmmsc_result_t *, void *),
				    void *user_data,
				    xmmsc_user_data_free_func_t free_func);
void xmmsc_result_wait (xmmsc_result_t *res);

int xmmsc_result_iserror (xmmsc_result_t *res);
const char * xmmsc_result_get_error (xmmsc_result_t *res);

int xmmsc_result_get_int (xmmsc_result_t *res, int32_t *r);
int xmmsc_result_get_uint (xmmsc_result_t *res, uint32_t *r);
int xmmsc_result_get_string (xmmsc_result_t *res, char **r);
int xmmsc_result_get_collection (xmmsc_result_t *conn, xmmsc_coll_t **coll);
int xmmsc_result_get_bin (xmmsc_result_t *res, unsigned char **r, unsigned int *rlen);

xmmsc_result_value_type_t xmmsc_result_get_dict_entry_type (xmmsc_result_t *res, const char *key);
int xmmsc_result_get_dict_entry_string (xmmsc_result_t *res, const char *key, char **r);
int xmmsc_result_get_dict_entry_int (xmmsc_result_t *res, const char *key, int32_t *r);
int xmmsc_result_get_dict_entry_uint (xmmsc_result_t *res, const char *key, uint32_t *r);
int xmmsc_result_get_dict_entry_collection (xmmsc_result_t *conn, const char *key, xmmsc_coll_t **coll);
void xmmsc_result_source_preference_set (xmmsc_result_t *res, const char **preference);

int xmmsc_result_is_list (xmmsc_result_t *res);
int xmmsc_result_list_next (xmmsc_result_t *res);
int xmmsc_result_list_first (xmmsc_result_t *res);
int xmmsc_result_list_valid (xmmsc_result_t *res);

xmmsc_result_value_type_t xmmsc_result_get_type (xmmsc_result_t *res);

const char *xmmsc_result_decode_url (xmmsc_result_t *res, const char *string);

/*
 * xmmsc_coll.h
 */

typedef struct xmmsc_coll_St xmmsc_coll_t;

typedef void (*xmmsc_coll_attribute_foreach_func) (const char *key, const char *value, void *udata);

xmmsc_coll_t* xmmsc_coll_new (const int type);
void xmmsc_coll_ref (xmmsc_coll_t *coll);
void xmmsc_coll_unref (xmmsc_coll_t *coll);

void xmmsc_coll_set_idlist (xmmsc_coll_t *coll, unsigned int ids[]);
void xmmsc_coll_add_operand (xmmsc_coll_t *coll, xmmsc_coll_t *op);
void xmmsc_coll_remove_operand (xmmsc_coll_t *coll, xmmsc_coll_t *op);

int xmmsc_coll_idlist_append (xmmsc_coll_t *coll, unsigned int id);
int xmmsc_coll_idlist_insert (xmmsc_coll_t *coll, unsigned int index, unsigned int id);
int xmmsc_coll_idlist_move (xmmsc_coll_t *coll, unsigned int index, unsigned int newindex);
int xmmsc_coll_idlist_remove (xmmsc_coll_t *coll, unsigned int index);
int xmmsc_coll_idlist_clear (xmmsc_coll_t *coll);
int xmmsc_coll_idlist_get_index (xmmsc_coll_t *coll, unsigned int index, uint32_t *val);
int xmmsc_coll_idlist_set_index (xmmsc_coll_t *coll, unsigned int index, uint32_t val);
size_t xmmsc_coll_idlist_get_size (xmmsc_coll_t *coll);

const int xmmsc_coll_get_type (xmmsc_coll_t *coll);
uint32_t* xmmsc_coll_get_idlist (xmmsc_coll_t *coll);
int xmmsc_coll_operand_list_first (xmmsc_coll_t *coll);
int xmmsc_coll_operand_list_valid (xmmsc_coll_t *coll);
int xmmsc_coll_operand_list_entry (xmmsc_coll_t *coll, xmmsc_coll_t **operand);
int xmmsc_coll_operand_list_next (xmmsc_coll_t *coll);
int xmmsc_coll_operand_list_save (xmmsc_coll_t *coll);
int xmmsc_coll_operand_list_restore (xmmsc_coll_t *coll);

void xmmsc_coll_attribute_list_first (xmmsc_coll_t *coll);
int xmmsc_coll_attribute_list_valid (xmmsc_coll_t *coll);
void xmmsc_coll_attribute_list_entry (xmmsc_coll_t *coll, const char **k, const char **v);
void xmmsc_coll_attribute_list_next (xmmsc_coll_t *coll);


void xmmsc_coll_attribute_set (xmmsc_coll_t *coll, const char *key, const char *value);
int xmmsc_coll_attribute_remove (xmmsc_coll_t *coll, const char *key);
int xmmsc_coll_attribute_get (xmmsc_coll_t *coll, const char *key, char **value);
void xmmsc_coll_attribute_foreach (xmmsc_coll_t *coll, xmmsc_coll_attribute_foreach_func func, void *user_data);

xmmsc_coll_t* xmmsc_coll_universe ();

/*
 * All about propdicts and dicts.  Or something.
 */

// From #xmms2:
// 09:53 < puzzles> yes, propdicts and dicts are not quite the same
// 09:53 < puzzles> propdicts have an additional property associated with the value, which is the source
// 09:55 < puzzles> but yeah, since multiple plugins might set the same attribute, there's a source, too.
//     example: id3v1 artist: Ulrich Schnau, id3v2 artist: Ulrich Schnauss
// [snip]
// 09:56 < rlpowell> So what about a client setting its own props?  Should it use the client name as source?
// 09:56 < puzzles> yes
// 09:56 < puzzles> and it will by default
// 09:56 < puzzles> it will show up under client/YourClientName
// 10:00 < rlpowell> So when I do get_info and then get_dict_entry_string "artist", if there's more than one set,
//     what is it that I'm retrieving?
// 10:02 < rlpowell> This is what the cli does for "xmms2 mlib search", for example.
// 10:02 < tru> well, the sources use priority.
// 10:02 < tru> which you can set with source_preference or something like that. [Ed: xmmsc_result_source_preference_set]
// 10:02 < tru> so it will give you the first in that priority.

/* The definitions below are based on these.
 * typedef void (*xmmsc_dict_foreach_func) (const void *key, xmmsc_result_value_type_t type, const void *value, void *user_data);
 * typedef void (*xmmsc_propdict_foreach_func) (const void *key, xmmsc_result_value_type_t type, const void *value, const char *
 * 						   source, void *user_data);
 */


___safe int xmmsc_result_dict_foreach(
			      xmmsc_result_t *res,
			      // was xmmsc_dict_foreach_func func,
			      void (*)(const void *, xmmsc_result_value_type_t, const void *, void*),
			      void *user_data );
___safe int xmmsc_result_propdict_foreach(
				  xmmsc_result_t *res,
				  // was xmmsc_propdict_foreach_func func,
				  void (*)(const void *, xmmsc_result_value_type_t, const void *, const char*, void*),
				  void *user_data );

/*
 * For reference only.  You can access these by using foreign-value, like so:
 * 	(foreign-value "XMMSC_RESULT_VALUE_TYPE_STRING" int)
 *
 * 
 * typedef enum {
 *         XMMSC_RESULT_VALUE_TYPE_NONE = XMMS_OBJECT_CMD_ARG_NONE,
 *         XMMSC_RESULT_VALUE_TYPE_UINT32 = XMMS_OBJECT_CMD_ARG_UINT32,
 *         XMMSC_RESULT_VALUE_TYPE_INT32 = XMMS_OBJECT_CMD_ARG_INT32,
 *         XMMSC_RESULT_VALUE_TYPE_STRING = XMMS_OBJECT_CMD_ARG_STRING,
 *         XMMSC_RESULT_VALUE_TYPE_DICT = XMMS_OBJECT_CMD_ARG_DICT,
 *         XMMSC_RESULT_VALUE_TYPE_PROPDICT = XMMS_OBJECT_CMD_ARG_PROPDICT,
 *         XMMSC_RESULT_VALUE_TYPE_COLL = XMMS_OBJECT_CMD_ARG_COLL,
 *         XMMSC_RESULT_VALUE_TYPE_BIN = XMMS_OBJECT_CMD_ARG_BIN
 * } xmmsc_result_value_type_t;
 */

char *xmmsc_userconfdir_get_with_leak();
<#

#>
// Call xmmsc_userconfdir_get with a home-made malloc, which we never free.
char *xmmsc_userconfdir_get_with_leak()
{
    char *buf = malloc( ( PATH_MAX + 1 ) * sizeof( char ));

    return xmmsc_userconfdir_get( buf, PATH_MAX );
}
<#

; **************
; Utility functions of my own design, which means they probably all
; suck.  :)
; **************

; Wait on a libxmmsclient result, and also return that result.
(define (xmms-wait call error-func)
  (xmmsc_result_wait call)
  (cond
    [(= (xmmsc_result_iserror call) 1)
     (error-func (xmmsc_result_get_error call))])
  call)

; Takes an xmms2 result that contains a string and extracts it
(define (xmms-result->string result error-func)
  (define-external ret_string c-string "!!!!!!!!")
  ; Just in case
  (xmms-wait result error-func)
  (xmmsc_result_get_string result (location ret_string))
  (let*
    ([return-string (string-copy ret_string)])
    (xmmsc_result_unref result)
    return-string))

; Takes an xmms2 result that contains an int and extracts it
(define (xmms-result->int result error-func)
  ; Just in case
  (xmms-wait result error-func)
  (let*
    ([int-vec (u32vector 999999)]
     [ret (xmmsc_result_get_uint result int-vec)]
     [int (u32vector-ref int-vec 0)])
    (xmmsc_result_unref result)
    int))

; Takes an xmms2 result that contains a list of ints and extracts them
(define (xmms-result->int-list result error-func)
  ; Just in case
  (xmms-wait result error-func)
  (let* ([id (u32vector 9999999)]
	 [valid (xmmsc_result_list_valid result)]
	 )
    (cond
      ((= 1 valid)
       ; Get the id of the current playlist bit
       (xmmsc_result_get_uint result id)
       ; Go to the next item
       (xmmsc_result_list_next result)
       (cons (u32vector-ref id 0) (result->int-list result)))
      (else '()))))

; Takes an xmms2 result that contains a list of strings and extracts them
(define (xmms-result->string-list result error-func)
  ; Just in case
  (xmms-wait result error-func)
  (let* ([valid (xmmsc_result_list_valid result)])
    (define-external val c-string "N/A")
    (cond
      [(and
	 (= 1 valid)
	 ; Get the string
	 (= 1 (xmmsc_result_get_string result (location val))))
       ; Go to the next item
       (xmmsc_result_list_next result)
       (cons val (result->string-list result))]
      [else '()])))

